/* Connect 4 */
/* My wonderful Connect4 Player implementation */
package Jesper;
import Player.Player;
import java.util.Random;
import java.util.Iterator;
import java.util.ArrayList;

public class Jesper implements Player 
{ 
    private int[][] boardArray;
    private Boolean color; 
    private int depth; 
    private int move;
    private Board board;
    private int anInt = 0;
    
    public Jesper()
    {
        boardArray = new int[6][7];
        board = new Board (boardArray);
        depth = 10; // write the depth of the search tree  
    }

    public void init (Boolean col)
     {
        this.color = col;
     }

    public String name()
     {
        String name = "Jesper";
        return name;
     }
     
    public int move()
     {
        anInt++;
// increasing depth after some moves. this is again not the most logical way to do this, but i am out of time 
        if (anInt == 6)
            depth = 11;
        if (anInt >= 10)
            depth = 12;            
// the first two moves are forced, thereby trying to give my otherwise stupid AI an okay starting point        
        if (anInt <= 1)
            move = 3;        
        else if (anInt == 2)
            move = 2;            
        else
        {
            MinMaxAB search = new MinMaxAB(board, depth, color);    
           search.max(Integer.MIN_VALUE, Integer.MAX_VALUE);
            move = search.getBest();
        }  
        this.board.insert(move, color);      
        return move;
     }

    public void inform (int m)
     {
        board.insert(m, !color);
     }   
}

class Board
{
    private int[][] boardArray;
    private int move;
    private Boolean player;
 
    public Board(int[][] aBoard)
     {
         boardArray = aBoard;
     }
    
    public Board(Board b)
    {
        boardArray = new int[6][7];
        int[][] board = b.getBoard();
        for (int i = 0; i < 6; i++)
        {
            for (int j = 0; j < 7; j++)
            {
                boardArray[i][j] = board[i][j];
            }
        }
    }
  
    public int getMove()
    {
        return this.move;
    }

    public int[][] getBoard()
    {
        return boardArray;
    }

    public void insert(int m, Boolean pl)
     {
        this.move = m;         
        this.player = pl;        
        if (isValid(move))
        {
            int playerSign; 
            if(player == true)
                playerSign = 1;
            else
                playerSign = 2;
           
            for(int row = 5; row >= 0; row--)
             {
                if(boardArray[row][m] == 0)
                 {
                    boardArray[row][m] = playerSign;
                    break;
                 }                   
             }
        }
        else
        {
            System.out.println("Error!!! Inserting a token in a random column");
            Random generator = new Random();
            this.insert (generator.nextInt(7), player);
        }

     }
    
    public boolean isValid(int m)
     {
        if (m >= 0 && m < 7 && boardArray[0][m] == 0)
            return true;
        else
            return false;
     }
                            
    public boolean win()
     {                    
        int playerSign; 
        if(this.player == true)
            playerSign = 1;
        else
            playerSign = 2;
        
        boolean success = false;                
                                    
    //check for a horisontal win
        for (int row = 0; row < 6; row++) 
         {
            for (int column = 0; column < 4; column++) 
             {
                if (boardArray[row][column] != 0 && 
                    boardArray[row][column] == playerSign &&
                    boardArray[row][column] == boardArray[row][column + 1] && 
                    boardArray[row][column] == boardArray[row][column + 2] &&
                    boardArray[row][column] == boardArray[row][column + 3]) 
                     {
                        success = true;
                     }
             }
         }
         
    //check for a vertical win
        for (int row = 0; row < 3; row++) 
         {
            for (int column = 0; column < 7; column++) 
             {
                if (boardArray[row][column] != 0 && 
                    boardArray[row][column] == playerSign &&
                    boardArray[row][column] == boardArray[row + 1][column] && 
                    boardArray[row][column] == boardArray[row + 2][column] &&
                    boardArray[row][column] == boardArray[row + 3][column]) 
                     {
                        success = true;
                     } 
             }
         }
                   
    //check for a diagonal win (positive slope)
        for (int row = 0; row < 3; row++) 
         {
            for (int column = 0; column < 4; column++) 
             {
                if (boardArray[row][column] != 0 && 
                    boardArray[row][column] == playerSign &&
                    boardArray[row][column] == boardArray[row + 1][column + 1] && 
                    boardArray[row][column] == boardArray[row + 2][column + 2] &&
                    boardArray[row][column] == boardArray[row + 3][column + 3]) 
                     {
                        success = true;
                     }
             }
         }
                    
    //check for a diagonal win (negative slope)
        for (int row = 0; row < 3; row++) 
         {  
            for (int column = 3; column < 7; column++) 
             {
                if (boardArray[row][column] != 0 && 
                    boardArray[row][column] == playerSign &&
                    boardArray[row][column] == boardArray[row + 1][column - 1] && 
                    boardArray[row][column] == boardArray[row + 2][column - 2] &&
                    boardArray[row][column] == boardArray[row + 3][column - 3]) 
                     {
                        success = true;
                     }
             }
         }       
        return success;
     }
                
    public boolean tie()
     {                 
        for (int row = 0; row < 6; row++)
         {
            for (int column = 0; column < 7; column++)
             {
                if (boardArray[row][column] == 0)
                    return false; //if the board is not empty, which means that it still contains zeroes then its not a tie
             }
         }  
        return true; //return true if it is a tie               
     }                                  
                     
    public void print()
     {  
        for (int i = 0; i < boardArray.length; i++ )
         {
            System.out.print("Row" + i + ": ");
            for (int col = 0; col < boardArray[i].length; col++ )
                System.out.print(boardArray[i][col] + " ");
            System.out.println();                       
         }              
     }                                  
}
//*****************************************************************************************//

class MinMaxAB
{
    private ArrayList<Board> boardList;
    private int best;
    private int depth;
    private Boolean color;
    private Board someBoard, aBoard;

    public MinMaxAB(Board board, int d, Boolean c)
    {
        someBoard = board;
        this.depth = d;        
        this.color = c;
        boardList = new ArrayList<Board>();
        
        if (someBoard.win())
        {        
        }
        else
        {
// some crude AI-optimization, could have been done nicer, but dont have the time :)
// the optimization is done in order to force the AI to put tokens in the middle columns
// otherwise it would put the tokens in the first column unles it found a winning move somewhere else
            for (int column = 3; column < 5; column++)
                {
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                }
            for (int column = 2; column == 2; column--)
                {                   
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                }
            for (int column = 5; column == 5; column--)
                {                 
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                } 
            for (int column = 1; column == 1; column--)
                {                
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                }   
            for (int column = 6; column == 6; column--)
                {                
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                }
            for (int column = 0; column == 0; column--)
                {                
                    aBoard = new Board(someBoard);
                    if (someBoard.isValid(column))
                    {
                    aBoard.insert(column, color);
                    boardList.add (aBoard);
                    }
                }                 
        }
    }
    public int getBest()
    {
        return best;
    }

    public int max (int alpha, int beta)
    {
        if (this.depth < 0)
            return 0;
        if (someBoard.win())            
            return -1;
        else if (someBoard.tie())            
            return 0;            
        else 
        {
            int newAlpha = alpha;
            best = boardList.get (0).getMove();
    
            for (Iterator<Board> i = boardList.iterator(); i.hasNext();)
            {
                Board board = i.next();
                int node = new MinMaxAB (board, this.depth - 1, !color).min (newAlpha, beta);
                if (newAlpha < node)
                {
                    newAlpha = node;
                    best = board.getMove();
                }
                if (beta <= newAlpha)
                {
                    return newAlpha;
                }
            }
            return newAlpha;
        }
    }
    
    public int min (int alpha, int beta)
    {
        if (this.depth < 0)
            return 0;
        if (someBoard.win())            
            return 1;
        else if (someBoard.tie())            
            return 0; 
        else 
        {
            int newBeta = beta;
            best = boardList.get (0).getMove();
            for (Iterator<Board> i = boardList.iterator (); i.hasNext (); )
            {
                Board board = i.next();
                int n = new MinMaxAB (board, this.depth - 1, !color).max (alpha, newBeta);
                if (n < newBeta)
                {
                    newBeta = n;
                    best = board.getMove();
                }
                if (newBeta <= alpha)
                {
                    return newBeta;
                }                
            }
            return newBeta;
        }
    }
}








