/*Connect4*/
/*MywonderfulConnect4Playerimplementation*/

package KimOlsen;

import Player.Player;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Random;
import javax.swing.JOptionPane;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.Iterator;

public class KimOlsen implements Player {
	Board board;
	Boolean player;


	public void init(Boolean colour) {
		this.board = new Board();
		this.player=colour;
	}

	public String name() {
		return "Automatic Kim";
	}

	public void inform(int i) {
		if (player) {
			try {board.insert(2,i);} catch (IllegalMove exn) {};
		} else {
			try {board.insert(1,i);} catch (IllegalMove exn) {};
		}
		this.board.printboard();			
	}

	public int move() {
		try {
			int i = move3();
 			board.printboard();			
			return (i);
		}
		catch (Exception exn) {
			return (this.move());
		}
	}

	public int rndMove() {
		Random generator = new Random();
		int ii;
		ii = generator.nextInt(7);
		if (player) {
			try {board.insert(1,ii);} catch (IllegalMove exn) {};
		} else {
			try {board.insert(2,ii);} catch (IllegalMove exn) {};
		}
//		this.board.printboard();			
		return (ii);
	}

	public int move3() {
		Stage start = new Stage(board, 1);
		start.max(-100000, 100000);
		if (player) {
			try {board.insert(1,start.best);} catch (IllegalMove exn) {};
		} else {
			try {board.insert(2,start.best);} catch (IllegalMove exn) {};
		}
		return (start.best);
	}
}

 class Stage {
    ArrayList<Board> boards = new ArrayList<Board> ();
    int player=1;
    int depth, best,minscore,maxscore;
    Boolean gameOver;

    Stage (Board b, int depth) {
	this.depth = depth;
	if (b.win ()) {this.gameOver = true;}
	else {
	    this.gameOver = false;
	    for (int i=0; i <= 6; i++) {
	    Board x=(Board)b.clone();//x.printboard();
		try { x.insert(player,i);boards.add (x);} catch (IllegalMove exn) {};//x.printboard();				
		
	    }
	}
    }
    
    public int max (int a, int b) {
	if (this.depth < 0) {return minscore;} 
	if (this.gameOver) {return 1;}
	else {
	    int newa = a;int j=0;
            best = boards.get (0).moveNo;
	    for (Iterator<Board> i = boards.iterator (); i.hasNext (); ) {
			Board board = i.next ();
			minscore = board.score(1,j);player=1;j++;
			int n = new Stage (board, this.depth-1).min (a, b);
                        if (newa < n) {newa = n; best = board.moveNo;}
			if (b <= newa) {return newa;}
	    }
	    return newa;
	}
    }

    public int min (int a, int b) {
	if (this.depth < 0) {return minscore;} 
	if (this.gameOver) {return -1;}
	else {
	    int newb = b;int j=0;
            best = boards.get (0).moveNo;
	    for (Iterator<Board> i = boards.iterator (); i.hasNext (); ) {	
			Board board = i.next();
			minscore = board.score(1,j);player=1;j++;
			int n = new Stage (board,  this.depth-1).max (a, b);
                        if (n < newb) {newb = n; best=board.moveNo;}
			if (newb <= a) {return newb;}
	    }
	    return newb;
	}
    }
}


//MessagePanel: Display a message on a JPanel

 class Board extends JPanel 
		implements MouseListener,ActionListener,Cloneable {
	int rect1xco,rect1yco,rect1width,rect1height;
	int xpos,ypos;
	boolean rect1Clicked, mouseEntered, waiting;
    int moveNo;
    Graphics g1;
    private int[][] grid;
    private int maxHeight;
    /**
     * Initializes a new Board
     */
    public Board() {
		grid = new int[6][7];
		for (int j = 0; j < 7; j++) {
			for (int i = 0; i < 6; i++) {
				grid[i][j] = 0;
			}
		}
      maxHeight = -1;
      moveNo = 0;
     }
    
    public void insert (int player, int move)  throws IllegalMove {
    	if (this.isValid (move)) {
    		this.moveNo=move;
    		int ii = 0;
    			for (int i = 5; i > 0; i--) {
    				if (grid[i][move]==0) { 
    					ii=i;i=-1;
    				}
    				}
    			grid[ii][move]=player;
    	    }
    	else {
    	    throw (new IllegalMove (move));
    	}
        }
    
    public void makemove(int colour,int move) {
        int ii = 0;
		for (int i = 5; i > 0; i--) {
			if (grid[i][move]==0) { 
				ii=i;i=-1;
			}
			}
		grid[ii][move]=colour;
		return;
	}

    private Boolean isValid (int m) {
    	if (m >=0 && m <= 6 && grid[0][m]==0) {return true;}
    	else {return false;}
        }

    public boolean win() {
		boolean win=false;
		for (int i = 0; i < 6; i++) {
			for (int j = 0; j < 7; j++) {
				int color=grid[i][j];
				// Vertical
	            if (i<3 &&  //only search where it is possibel to have 4 in a row  
	            	color != 0 &&
	                color==grid[i+1][j] && 
	                color==grid[i+2][j] &&
	                color==grid[i+3][j]) {
	                	win=true;
	            	}
				// Horizontal
	            if (j<4 &&  
	              	color != 0 &&
	                color==grid[i][j+1] && 
	                color==grid[i][j+2] &&
	                color==grid[i][j+3]) {
	                	win=true;
	            	}
				// 1. Diagonal 
	            if (i<3 && j<4 &&  
	              	color != 0 &&
	                color==grid[i+1][j+1] && 
	                color==grid[i+2][j+2] &&
	                color==grid[i+3][j+3]) {
	                	win=true;
	            	}
				// 2. Diagonal
	            if (i<3 && j>3 &&  
	              	color != 0 &&
	                color==grid[i+1][j-1] && 
	                color==grid[i+2][j-2] &&
	                color==grid[i+3][j-3]) {
	                	win=true;
	            	}
	 			}
			}
		return win;
	}

public int score(int player, int move) {
	int score = 0;
	int oppo;
	int j = move;
	if (win()){return 500;}
	if (player == 1) {
		oppo = 2;
	} else {
		oppo = 1;
	}
	if (j == 3) score = 10000;
	for (int i = 5; i > 0; i--) {
		if (player == grid[i][j]) {
			// 3. in a row would gain 10 in score
			// Vertical
			if (i > 3
					&& // only search where it is possible to have
					(player == grid[i][j] || 0 == grid[i][j])
					&& (player == grid[i - 1][j] || 0 == grid[i - 1][j])
					&& (player == grid[i - 2][j] || 0 == grid[i - 2][j])) {
				score = score + 16;
			}
			// Horizontal
			if (j < 4 && (player == grid[i][j + 1] || 0 == grid[i][j + 1])
					&& (player == grid[i][j + 2] || 0 == grid[i][j + 2])
					&& (player == grid[i][j + 3] || 0 == grid[i][j + 3])) {
				score = score + 16;
			}
			// 1. Diagonal
			if (i > 3
					&& j < 4
					&& (player == grid[i - 1][j + 1] || 0 == grid[i - 1][j + 1])
					&& (player == grid[i - 2][j + 2] || 0 == grid[i - 2][j + 2])
					&& (player == grid[i - 3][j + 3] || 0 == grid[i - 3][j + 3])) {
				score = score + 16;
			}
			// 2. Diagonal
			if (i > 3
					&& j > 3
					&& (player == grid[i - 1][j - 1] || 0 == grid[i - 1][j - 1])
					&& (player == grid[i - 2][j - 2] || 0 == grid[i - 2][j - 2])
					&& (player == grid[i - 3][j - 3] || 0 == grid[i - 3][j - 3])) {
				score = score + 16;
			}
			// Opponents status
			if (i > 3
					&& // only search where it is possible to have
					// 4 in
					// a row
					(oppo == grid[i - 1][j] || 0 == grid[i - 1][j])
					&& (oppo == grid[i - 2][j] || 0 == grid[i - 2][j])
					&& (oppo == grid[i - 3][j] || 0 == grid[i - 3][j])) {
				score = score + 14;
			}
			// Horizontal
			if (j < 4 && (oppo == grid[i][j + 1] || 0 == grid[i][j + 1])
					&& (oppo == grid[i][j + 2] || 0 == grid[i][j + 2])
					&& (oppo == grid[i][j + 3] || 0 == grid[i][j + 3])) {
				score = score + 14;
			}
			// 1. Diagonal
			if (i > 3
					&& j < 4
					&& (oppo == grid[i - 1][j + 1] || 0 == grid[i - 1][j + 1])
					&& (oppo == grid[i - 2][j + 2] || 0 == grid[i - 2][j + 2])
					&& (oppo == grid[i - 3][j + 3] || 0 == grid[i - 3][j + 3])) {
				score = score + 14;
			}
			// 2. Diagonal
			if (i > 3
					&& j > 3
					&& (oppo == grid[i - 1][j - 1] || 0 == grid[i - 1][j - 1])
					&& (oppo == grid[i - 2][j - 2] || 0 == grid[i - 2][j - 2])
					&& (oppo == grid[i - 3][j - 3] || 0 == grid[i - 3][j - 3])) {
				score = score + 14;
			}
			// Two in a row
			if (i > 3
					&& // vertical
					(player == grid[i - 1][j] || 0 == grid[i - 1][j])
					&& (player == grid[i - 2][j] || 0 == grid[i - 2][j])) {
				score = score + 4;
			}
			// Horizontal
			if (j < 4 && (player == grid[i][j + 1] || 0 == grid[i][j + 1])
					&& (player == grid[i][j + 2] || 0 == grid[i][j + 2])) {
				score = score + 4;
			}
			// 1. Diagonal
			if (i > 3
					&& j < 4
					&& (player == grid[i - 1][j + 1] || 0 == grid[i - 1][j + 1])
					&& (player == grid[i - 2][j + 2] || 0 == grid[i - 2][j + 2])) {
				score = score + 4;
			}
			// 2. Diagonal
			if (i > 3
					&& j > 3
					&& (player == grid[i - 1][j - 1] || 0 == grid[i - 1][j - 1])
					&& (player == grid[i - 2][j - 2] || 0 == grid[i - 2][j - 2])) {
				score = score + 4;
			}
			if (i > 3
					&& // Oppo Vertical
					(oppo == grid[i - 1][j] || 0 == grid[i - 1][j])
					&& (oppo == grid[i - 2][j] || 0 == grid[i - 2][j])) {
				score = score + 6;
				// Horizontal
				if (j < 4
						&& (oppo == grid[i][j + 1] || 0 == grid[i][j + 1])
						&& (oppo == grid[i][j + 2] || 0 == grid[i][j + 2])) {
					score = score + 6;
				}
				// 1. Diagonal
				if (i > 3
						&& j < 4
						&& (oppo == grid[i - 1][j + 1] || 0 == grid[i - 1][j + 1])
						&& (oppo == grid[i - 2][j + 2] || 0 == grid[i - 2][j + 2])) {
					score = score + 6;
				}
				// 2. Diagonal
				if (i > 3
						&& j > 3
						&& (oppo == grid[i - 1][j - 1] || 0 == grid[i - 1][j - 1])
						&& (oppo == grid[i - 2][j - 2] || 0 == grid[i - 2][j - 2])) {
					score = score + 6;
				}
			}
		}
	}
	return score;
}

	public int printboard() {
		System.out.println("");
		System.out.print("Connect 4");
		System.out.println("");
		System.out.print("!-!!-!!-!!-!!-!!-!!-!");
		for (int i = 0; i < 6; i++) {
			System.out.println("!");
			for (int j = 0; j < 7; j++) {
				System.out.print("!");
				System.out.print(grid[i][j]);
				System.out.print("!");
				}
			}
		System.out.println("");
		System.out.print("!-!!-!!-!!-!!-!!-!!-!");
		return 0;
	}
	

    public void draw() {
        for (int j=0;j<7;j++) {
            for (int i=0;i<6;i++) {
            	if (grid[i][j]==1) g1.setColor(Color.red);
            	if (grid[i][j]==2) g1.setColor(Color.blue);
            	if (grid[i][j]==0) g1.setColor(Color.gray);
            	g1.fillOval(50+j*100,50+i*100, 80, 80);
            	}
        	}
    	addMouseListener(this);
    	g1.setColor(Color.green);
    	g1.drawString("Your Move : " +  moveNo,100,20);
    	repaint();
    }
        
    public void paintComponent(Graphics g) {
	super.paintComponent(g);
	g1=g;
    for (int j=0;j<7;j++) {
        for (int i=0;i<6;i++) {
        	if (grid[i][j]==1) g.setColor(Color.red);
        	if (grid[i][j]==2) g.setColor(Color.blue);
        	if (grid[i][j]==0) g.setColor(Color.gray);
        	g.fillOval(50+j*100,50+i*100, 80, 80);
        	}
    	}
	addMouseListener(this);
	g.setColor(Color.green);
	g.drawString("Your Move : " +  moveNo,100,20);
}

    public void actionPerformed(ActionEvent e)
    {
      System.out.println("Tastet 1");
      moveNo=1;
    }  
    
    public void mouseClicked (MouseEvent me) {
// Choose move by clicking in the right col - typical just on the brick
//  First get mouse position when the click is performed
    	xpos = me.getX();
		ypos = me.getY();	
	/* The Board is 800 wide and the bricks are 80 long
	   From 0-139 is col 0, from 140-240 is col 1 etc.
	*/
	 if (xpos > 0 && xpos < 140) {
	     moveNo = 0;
	 } else {
		 if (xpos > 139 && xpos < 240) {
		     moveNo = 1;
		 } else {
			 if (xpos > 239 && xpos < 340) {
			     moveNo = 2;
			 } else {
				 if (xpos > 339 && xpos < 440) {
				     moveNo = 3;
				 } else {
					 if (xpos > 439 && xpos < 550) {
					     moveNo = 4;
					 } else {
						 if (xpos > 539 && xpos < 640) {
						     moveNo = 5;
						 } else {
							 moveNo = 6;
						 }
					 }
				 }
			 }
		 }
	 }
	 repaint();
    }
    
// A Couple of interface methods which should be here
// but are not used in this game
public void mousePressed (MouseEvent me) {}
public void mouseReleased (MouseEvent me) {} 
public void mouseEntered (MouseEvent me) {}
public void mouseExited (MouseEvent me) {}

public Object clone() {
	try {
		Board copy = (Board) super.clone();
		copy.grid = new int[6][7];
		for (int j = 0; j < 7; j++) {
			for (int i = 0; i < 6; i++) {
				copy.grid[i][j] = grid[i][j];
			}
		}

		return copy;
	} catch (CloneNotSupportedException e) {
		throw new InternalError(e.toString());
	}
}
}

class IllegalMove extends Exception {
    int m; 
    IllegalMove (int m) {
	this.m = m;
    }
}
