package Marguerite;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

public class GUI 
{
	public GUI(Board board)
	{	
		aBoard = board;
		BoardComponent boardComp = new BoardComponent(aBoard);
		
		//Create a frame in which the game should be placed
		frame = new JFrame();
		frame.setSize(708, 657);
		frame.setTitle("Connect Four Game");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		  
		//Create the menu bar to be in the top of the frame
		menuBar = new JMenuBar(); 
		fileMenu = new JMenu("File");
		
		//Items in roll-down menu's with listeners attached
		JMenuItem newGame = new JMenuItem("New Game");
		GameListener newGameListener = new GameListener();
		newGame.addActionListener(newGameListener);
		JMenuItem quitGame = new JMenuItem("Quit Game");
		GameListener quitGameListener = new GameListener();
		quitGame.addActionListener(quitGameListener);
		
		//Items added to the menu bar, 
		//which is attached to the top of the frame
		fileMenu.add(newGame);
		fileMenu.add(quitGame);
		menuBar.add(fileMenu);
		frame.setJMenuBar(menuBar);
		
    	//The visual representation of the board 
		//(the Board Component)
		frame.add(boardComp, BorderLayout.CENTER);
	
		frame.setVisible(true);
	}

	
	//Display the game on the screen
	void display()
	{
		frame.repaint();
	}
	
	//Create new GUI
	public void newGameBoard()
	{
		Board newBoard = new Board();
		GUI newGui = new GUI(newBoard);
		newGui.display();
	}
	

	
	//Creates a listener to the two items in the menu bar
	class GameListener implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			String choise = event.getActionCommand();
			// if "New Game" - a new game is started
			if (choise.equals("New Game")) 
			{
				aBoard.resetGame();
				newGameBoard();
				display();
				
			}
			//if "Quit" - the play is closed
			else if(choise.equals("Quit Game")) 
			{
				System.exit(0);
			}
		}	
	}
	
	Board aBoard;
	BoardComponent boardComp;
	private JFrame frame;
	private JMenuBar menuBar; 
	private JMenu fileMenu; 
}