package Marguerite;

import Player.Player;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.geom.Ellipse2D;
import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.JComponent;


	
	
	class ConnectFour {
	    Board b; 
	    Player p1;		/* p1 plays true */
	    Player p2; /* p2 plays false */
	    GUI gui;

	    ConnectFour (Player p1, Player p2) 
	    {
	   	b = new Board();
//		    init ();
			this.p1 = p1; 
			this.p2 = p2;
			gui = new GUI(b);
			
			p1.init(true);
			p2.init(false);
			
	    }

//	    void init () {
//		b = new Board ();

	    //Prints out to the console if move is illegal
	    void illegal (String s, int i) {
		System.out.println ("Illegal Move: Player " +  s + " moved to " + i);
	    }

	    //Move of the players
	    int move (Boolean player) 
	    {	//Prints out board
	    	b.print ();
	    	//Displays the Graphical User Interface
	    	gui.display();
		
	    	//Ask the player to do a move in the console
	    	if (player) 
	    	{
	    		System.out.println (p1.name() + " please make your move");
	    	}
		    else 
		    {
		    	System.out.println (p2.name() + " please make your move");
		    }

	    	//If there is a tie, the game is over
	    	if (b.tie ()) 
	    	{
	    		System.out.println ("Tie!"); return 0;
	    	}
	    	
	    	//else the players is asked to do a move
	    	else 
	    	{
			    if (player) 
			    {
			    	int m = p1.move ();
			    	System.out.println ("Move:" + m);
			    	try 
			    	{
			    		b.insert (m, player); 
			    	}
			    	catch (IllegalMove exn) 
			    	{
			    		this.illegal (p1.name(), exn.i); 
			    		return 2;
			    	}
			    	if (b.win(player)) 
			    	{
			    		gui.display();
			    		System.out.println ("Winner:" + p1.name()); return 1;
			    	}
			    	p2.inform (m); //
			    }
			    else 
			    {
					int m = p2.move ();
					System.out.println ("Move:" + m);
					try 
					{
						b.insert (m, player);
					}
					catch (IllegalMove exn) 
					{
						this.illegal (p2.name(), exn.i); return 1;
					}
					if (b.win (player)) 
					{
						gui.display();
						System.out.println ("Winner:" + p2.name()); return 2;
					}
					p1.inform (m);
			    }
			    b.print();
			    gui.display();
			    return (move (!player));
	    	}
	    }
	    
	    int run () 
	    {
//			this.init ();
			int result = this.move (true);
			b.print ();
			gui.display();
			return (result);	
	    }

	}
//	    public static void main  (String [] args) 
//		throws java.lang.ClassNotFoundException,
//		       java.lang.InstantiationException,
//		       java.lang.IllegalAccessException
//	    { 
//	       
////			String a = args[0];
////			Class ac = Class.forName(a);
////			Object ao =  ac.newInstance ();
////			String b = args[1];
////			Class bc = Class.forName(b);
////			Object bo = bc.newInstance ();
	//	
	//
////			ConnectFour c = new ConnectFour ((Player) ao, (Player)bo);
////		c.run ();
//	    	try {
//				ConnectFour game =  new ConnectFour(new Player() , new Player());
//				game.run();
//			}
//			catch(IllegalStateException e)
//			{
//				System.exit(1);
//			}
//	    }
	//
	//}

        class Board 
	{
		private int n;
		private int[][] board;
		private static final int ROWS = 6;
		private static final int COLUMNS = 7;

		/**
		 * Constructs a board 
		 */
		public Board()
		{
			//Initialize the board.
			board = new int[COLUMNS][ROWS];
			n = 0;
			//Fill with the board with "0" 
			//(1 is the value of red, -1 is the value of yellow)
			for (int i = 0; i<ROWS; i++)
			{
				for(int j = 0; j < COLUMNS; j++)
					board[j][i] = 0;
			}
		}
		
		/** 
		 * @param col 	Column to put token into
		 * @param player color of the player
		 * @throws IllegalMove 
		 */
		public void insert(int col, boolean playerP) 
									throws IllegalMove
		{	
			int player;
			if (playerP)
			{player = 1;}
			else{
				player = -1;}
			
			if(this.isValid(col))
			{
				for (int row = ROWS-1; row>= 0; row--)
				{
					if(board[col][row] == 0)
					{
						board[col][row] = player;
						break;
					}
				}
			}
			else
			{
				throw (new IllegalMove(col));
			}
		}
		
		//Is only in program to predict the future moves
		public void insert(int col) throws IllegalMove
		{		
			
			
			int player;
			if ((n++)%2==0)
			{player = 1;}
			else{
				player = -1;}
			
			if(this.isValid(col))
			{
				for (int row = ROWS-1; row>= 0; row--)
				{
					if(board[col][row] == 0)
					{
						board[col][row] = player;
						break;
					}
				}
			}
			else
			{
				throw (new IllegalMove(col));
			}
		}
		
		//Check if move is legal
		Boolean isValid(int col)
		{
			if (col <= 6)
			{
				if(!(board[col][0]== -1)||(board[col][0]==1))
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else return false;
		}
		
		public boolean tie()
		{
			boolean tiePlay = true;
			
			for (int row = 0; row<ROWS; row++)
			{
				for(int col = 0; col < COLUMNS; col++)
				{
					if((board[col][row]==0))
						{
						tiePlay = false;
						}
				}
			}
			return tiePlay;
		}

		/**
		 * Check if the board has a winning situation
		 * Goes through all indexes of the board to check whether the index 
		 * could be the first token in a row of 4 in the horizontal, 
		 * the vertical or the diagonal direction.
	     * If all four are the color of the same - we have a winner
		 */
		public boolean win(boolean pl)
		{
			int player;
			if (pl)
			{player = 1;}
			else{
				player = -1;}
			
			for(int row = 0; row < ROWS; row++)
			{ 
				for (int col = 0; col < COLUMNS; col++)
				{ 
					//Goes through all rows to check if 
					//there is a winning situation
					if ((row+3) < ROWS)
					{
						if (board[col][row] == player && 
								board[col][row+1] == player &&
								board[col][row+2] == player && 
								board[col][row+3] == player)
						{
							return true;
						}
					}
					
					//Goes through all columns to check 
					//if there is a winning situation
					if((col+3) < COLUMNS)
					{
						if (board[col][row] == player && 
								board[col+1][row] == player &&
								board[col+2][row] == player && 
								board[col+3][row] == player)
						{
							return true;
						}
					}
					
					//Goes through all diagonals to check 
					//if there is a winning situation
					if((row + 3) < ROWS && (col+3) < COLUMNS)
					{
						if(board[col][row] == player && 
								board[col+1][row+1] == player &&
								board[col+2][row+2] == player && 
								board[col+3][row+3] == player)
						{
							return true;
						}
					}
					
					//Goes through all diagonals (opposite) to check 
					//if there is a winning situation
					 if ((row - 3)> 0 && (col+3) < COLUMNS )
					{
						if(board[col][row] == player && 
								board[col+1][row-1] == player &&
								board[col+2][row-2] == player && 
								board[col+3][row-3] == player)
						{
							return true;
						}
					}
				}
			}
			return false;	
		}
		
		//Same as previous - but doesn't need any parameter
		public boolean isWin()
		{
			int player;
			if ((n++)%2==0)
			{
				player = 1;
			}
			else
			{
				player = -1;
			}
			
			for(int row = 0; row < ROWS; row++)
			{ 
				for (int col = 0; col < COLUMNS; col++)
				{ 
					//Goes through all rows to check 
					//if there is a winning situation
					if ((row+3) < ROWS)
					{
						if (board[col][row] == player && 
								board[col][row+1] == player &&
								board[col][row+2] == player && 
								board[col][row+3] == player)
						{
							return true;
						}
					}
					
					//Goes through all columns to check 
					//if there is a winning situation
					if((col+3) < COLUMNS)
					{
						if (board[col][row] == player && 
								board[col+1][row] == player &&
								board[col+2][row] == player && 
								board[col+3][row] == player)
						{
							return true;
						}
					}
					
					//Goes through all diagonals to check 
					//if there is a winning situation
					if((row + 3) < ROWS && (col+3) < COLUMNS)
					{
						if(board[col][row] == player && 
								board[col+1][row+1] == player &&
								board[col+2][row+2] == player && 
								board[col+3][row+3] == player)
						{
							return true;
						}
					}
					
					//Goes through all diagonals (opposite) to check 
					//if there is a winning situation
					 if ((row - 3)> 0 && (col+3) < COLUMNS )
					{
						if(board[col][row] == player && 
								board[col+1][row-1] == player &&
								board[col+2][row-2] == player && 
								board[col+3][row-3] == player)
						{
							return true;
						}
					}
				}
			}
			return false;	
		}
		
		//Gets the current board situation 
		//and return it in a double array
		public int[][] getBoard()
		{	
			return board;
		}
		
		
		public Board resetGame()
		{
			Board newBoard = new Board();
			return newBoard;
		}
		
		
		//Prints the game on the console
		public void print()
		{		
				System.out.print("| " + board[0][0]);
				System.out.print(" | " + board[1][0]);
				System.out.print(" | " + board[2][0]);
				System.out.print(" | " + board[3][0]);
				System.out.print(" | " + board[4][0]);
				System.out.print(" | " + board[5][0]);
				System.out.print(" | " + board[6][0] + " |\n");
				System.out.print("| " + board[0][1]);
				System.out.print(" | " + board[1][1]);
				System.out.print(" | " + board[2][1]);
				System.out.print(" | " + board[3][1]);
				System.out.print(" | " + board[4][1]);
				System.out.print(" | " + board[5][1]);
				System.out.print(" | " + board[6][1] + " |\n");
				System.out.print("| " + board[0][2]);
				System.out.print(" | " + board[1][2]);
				System.out.print(" | " + board[2][2]);
				System.out.print(" | " + board[3][2]);
				System.out.print(" | " + board[4][2]);
				System.out.print(" | " + board[5][2]);
				System.out.print(" | " + board[6][2] + " |\n");
				System.out.print("| " + board[0][3]);
				System.out.print(" | " + board[1][3]);
				System.out.print(" | " + board[2][3]);
				System.out.print(" | " + board[3][3]);
				System.out.print(" | " + board[4][3]);
				System.out.print(" | " + board[5][3]);
				System.out.print(" | " + board[6][3] + " |\n");
				System.out.print("| " + board[0][4]);
				System.out.print(" | " + board[1][4]);
				System.out.print(" | " + board[2][4]);
				System.out.print(" | " + board[3][4]);
				System.out.print(" | " + board[4][4]);
				System.out.print(" | " + board[5][4]);
				System.out.print(" | " + board[6][4] + " |\n");
				System.out.print("| " + board[0][5]);
				System.out.print(" | " + board[1][5]);
				System.out.print(" | " + board[2][5]);
				System.out.print(" | " + board[3][5]);
				System.out.print(" | " + board[4][5]);
				System.out.print(" | " + board[5][5]);
				System.out.print(" | " + board[6][5] + " |\n \n");
			}
		
	}
	class GUI 
	{
		Board aBoard;
		BoardComponent boardComp;
		private JFrame frame;
		private JMenuBar menuBar; 
		private JMenu fileMenu; 
		public GUI(Board board)
		{	
			aBoard = board;
			BoardComponent boardComp = new BoardComponent(aBoard);
			
			//Create a frame in which the game should be placed
			frame = new JFrame();
			frame.setSize(708, 657);
			frame.setTitle("Connect Four Game");
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			  
			//Create the menu bar to be in the top of the frame
			menuBar = new JMenuBar(); 
			fileMenu = new JMenu("File");
			
			//Items in roll-down menu's with listeners attached
			JMenuItem newGame = new JMenuItem("New Game");
			GameListener newGameListener = new GameListener();
			newGame.addActionListener(newGameListener);
			JMenuItem quitGame = new JMenuItem("Quit Game");
			GameListener quitGameListener = new GameListener();
			quitGame.addActionListener(quitGameListener);
			
			//Items added to the menu bar, 
			//which is attached to the top of the frame
			fileMenu.add(newGame);
			fileMenu.add(quitGame);
			menuBar.add(fileMenu);
			frame.setJMenuBar(menuBar);
			
	    	//The visual representation of the board 
			//(the Board Component)
			frame.add(boardComp, BorderLayout.CENTER);
		
			frame.setVisible(true);
		}

		
		//Display the game on the screen
		void display()
		{
			frame.repaint();
		}
		
		//Create new GUI
		public void newGameBoard()
		{
			Board newBoard = new Board();
			GUI newGui = new GUI(newBoard);
			newGui.display();
		}
		

		
		//Creates a listener to the two items in the menu bar
		class GameListener implements ActionListener
		{
			public void actionPerformed(ActionEvent event)
			{
				String choise = event.getActionCommand();
				// if "New Game" - a new game is started
				if (choise.equals("New Game")) 
				{
					aBoard.resetGame();
					newGameBoard();
					display();
					
				}
				//if "Quit" - the play is closed
				else if(choise.equals("Quit Game")) 
				{
					System.exit(0);
				}
			}	
		}



}
	class BoardComponent extends JComponent
	{
		public BoardComponent(Board board) 
		{
			b = board;
		}
			public void paintComponent(Graphics g)
			{
				//Get the current board situation
				int[][] myBoard = b.getBoard(); 
				
				Graphics2D g2 = (Graphics2D) g;
				g2.setColor(Color.gray);
				
				// draws the background of the 7 columns
				g2.fill(new Rectangle(0 , 0, 700, 600));
							
				for (int col = 0; col<=6; col++) // gives 7 columns
				{
					for (int row = 5; row >= 0; row--) // gives 6 rows
					{
						if(myBoard[col][row] == 0)
								g2.setColor(Color.black);
						else if(myBoard[col][row]==1)
							g2.setColor(Color.RED);
						else
							g2.setColor(Color.YELLOW);
						g2.fill(new Ellipse2D.Double
								(710 - (7-col)*100, row *100 + 10, 80, 80));
					}		
				}
			}
			
			int[][] myBoard;
			Board b;
	}
	
	class IllegalMove extends Exception 
	{
	    int i; 
	    IllegalMove (int i) {
		this.i = i;
	    }
	}
	
	public class Marguerite implements Player
	{ 

		Board board; 
		
		/**
		 * Construct the Automatic player
		 * @param name the name of the player
		 */
		public Marguerite ()
		{
			board = new Board();
		}
		
		//return the name of the automatic player
		public String name () 
		{ 
			return "Marguerite";
		}

		public void init (Boolean color) 
		{
		}
		
		//The move of the automatic player
		public int move () { 
			Stage start = new Stage (board.getBoard(), 5); 
			start.max (-20.0, 20.0);
			try 
			{
				board.insert(start.best);
			} 
			catch (IllegalMove exn) {}
			return (start.best);
		}
		
		//Get's information of the last move of the opponent. Update board
		public void inform (int i) 
		{
			try 
			{
				board.insert (i);
			} 
			catch (IllegalMove exn) {};
			
		}

	}
	
	class Stage 
	{
		//A list of possible moves to make for the player
		ArrayList<Pair> moveAndBoard = new ArrayList<Pair> ();
	    //The best move to make
	    int best;
	    //How  many moves to see forward
	    int depth;
	    //If game over, return true
	    boolean gameOver;
	    private int [][] myBoard;
	    private int nextColMove;
		public boolean player;
		private int RedPlayer = 1;
		private int YellowPlayer = -1;
		private int myToken;
		private static final int COLUMNS = 7;
		private static final int ROWS= 6;
	    	
	    /**
	     * 
	     * @param b		the current board situation
	     * @param depth	The number of moves seen forward
	     */
	    Stage (int [][] b, int depth) 
	    {
	    	int [][] myBoard = b;		
	    	this.depth = depth;
	    	
	    	if (player)
	    		myToken = YellowPlayer;
	    	else
	    		myToken = RedPlayer;
	    	
	    	//If no winner, the possibilities of how the board 
	    	//could be set is added to the array list. 
	    	//All the columns is tried.
	    	if(Winner(myBoard))
	    	{
	    		this.gameOver = true;
	    	}
	    	else
	    		// Iterate through the columns and choose a play
	    		for(int row = 0; row < ROWS; row ++)
	    		{
	    			for(int col = 0; col <= (COLUMNS - 1) ; col++) 
	    			{
	    				if(legalMove(col))
	    				{   
	    					int myMove = col;
	    					//The field is given a value
		    				myBoard[col][row]= myToken; 	

		    				//The move and the board situation are put 
		    				//together in a pair
		    				Pair nextPair = new Pair(myMove, myBoard);
		    				moveAndBoard.add(nextPair);
		    				System.out.println("Length of arrayList Pair(inde)" + moveAndBoard.size());
		    				

	    				}
	    			}
	    		}
	    	
	    }

	    public int getColMove()
	    {
	    	return nextColMove;
	    }
	    
			double max (double a, double b) 
		    {
				System.out.println("Length of arrayList Pair" + moveAndBoard.size());
		    	//If the request of future moves is 
				//less than zero - return 0.0
		    	if (this.depth < 0) {return 0.0;} 
		    	//If the game is over, return 1.0
		    	if (this.gameOver) {return -1.0;}
			
		    	else 
		    	{
		    		double newa = a;
		    		//Returns the move of the first board situation 
		    		//of the array list
		    		best = moveAndBoard.get(0).getMove();
		    		
		    		//gets the column of which the token is put into
		    		
		    		//Iterates through the whole array list of boards 
		    		//to find the best 
		    		//way for the player to play
		    		for (Iterator<Pair> i = moveAndBoard.iterator(); i.hasNext(); ) 
		    		{
		    			Pair p = i.next();
		    			int[][] board = p.getNextBoard();
		    			
		    			double n = new Stage (board, this.depth-1).min (a, b);
		    			System.out.println("n: " + n);
		    			if (newa < n) 
		    			{
		    				newa = n; best = moveAndBoard.get(0).getMove();;
		    				System.out.println("I'm here in board if (newa < n)");
		    			}
		    			if (b <= newa) 
		    			{
		    				return newa;
		    			}
		    		}
		    		return newa;
		    	}
		    }
		
		    double min (double a, double b) 
		    {
		    		if (this.depth < 0) 
		    		{
		    			return 0.0;
		    		} 
			
		    		if (this.gameOver) 
		    		{
		    			return 1.0;
					}
				
				else 
				{
				    double newb = b;
				    //Best move is the move of the first board
				    best = moveAndBoard.get(0).getMove();
				    //Iterates through the whole array list of boards 
				    //to find the best way for the player to play
				    for (Iterator<Pair> i = moveAndBoard.iterator (); i.hasNext (); ) 
				    {	
				    	Pair p = i.next();
				    	int[][] board = p.getNextBoard();
				    	double n = new Stage (board,  this.depth-1).max (a, b);
				    	if (n < newb) 
				    	{
				    		newb = n; best = moveAndBoard.get(0).getMove();
				    		System.out.println("I'm here in board if (n<newb)");
				    	}
						if (newb <= a) 
						{
							return newb;
						}
			    }
				    return newb;
			}
	    }
		   //Checks whether the move is legal or not. 
		   //Parameter is the chosen column to play.
		   public boolean legalMove(int col)
		   {
			   if (col <= 6)
				{
					if(!(myBoard[col][0]== -1)||(myBoard[col][0]==1))
					{
						return true;
					}
					else
					{
						return false;
					}
				}
				else return false;
		   }
		    
		   //Returns true if four fields in a row in the double array 
		   //has the same value.
		    public boolean Winner(int[][]board)
		    {
		    	myBoard = board; 
		    	boolean win = false;
		    		
		    		for(int row = 0; row < ROWS; row++)
		    		{ 
		    			for (int col = 0; col < COLUMNS; col++)
		    			{ 
		    				
		    				//Goes through all rows to check 
		    				//if there is a winning situation
		    				if ((row+3) < ROWS)
		    				{
		    					if (myBoard[col][row] == myBoard[col][row+1] && 
		    							myBoard[col][row] == myBoard[col][row+2] &&
		    							myBoard[col][row]== myBoard[col][row+3] &&
		    							myBoard[col][row]!= 0)
		    					{
		    						win = true;
		    					}
		    				}
		    				
		    				//Goes through all columns to check 
		    				//if there is a winning situation
		    				if((col+3) < COLUMNS)
		    				{
		    					if (myBoard[col][row] ==  myBoard[col+1][row] &&
		    							myBoard[col][row] == myBoard[col+2][row] &&
		    							myBoard[col][row]== myBoard[col+3][row] &&
		    							myBoard[col][row]!= 0)
		    					{
		    						win = true;
		    					}
		    				}
		    				
		    				//Goes through all diagonals to check 
		    				//if there is a winning situation
		    				if((row + 3) < ROWS && (col+3) < COLUMNS)
		    				{
		    					if(myBoard[col][row] == myBoard[col+1][row+1] &&
		    							myBoard[col][row] == myBoard[col+2][row+2] && 
		    							myBoard[col][row] == myBoard[col+3][row+3] &&
		    							myBoard[col][row] != 0)
		    					{
		    						win = true;
		    					}
		    				}
		    				
		    				//Goes through all diagonals (opposite) to check 
		    				//if there is a winning situation
		    				 if ((row - 3)> 0 && (col+3) < COLUMNS )
		    				{
		    					if(myBoard[col][row] == myBoard[col+1][row-1] &&
		    							myBoard[col][row] == myBoard[col+2][row-2] &&
		    							myBoard[col][row] == myBoard[col+3][row-3] &&
		    							myBoard[col][row] != 0)
		    					{
		    						win = true;
		    					}
		    				}
		    			}
		    		}
		    		return win;	
		    	}
		 
		    //A class to put a possible move and the following 
		    //game board together in a pair
		    class Pair
		    {
		    	private int move;
		    	private int[][] boardView;
		    	
		    	public Pair (int move, int[][] boardView)
		    	{
		    		this.move = move;
		    		this.boardView = boardView;
		    	}
		    	 
		    	public int getMove()
		    	{
		    		return move;
		    	}
		    	
		    	public int[][] getNextBoard()
		    	{
		    		return boardView;
		    	}
		    }
	}
	
