package Marguerite;
import java.util.ArrayList;
import java.util.Iterator;

public class Stage 
{
	//A list of possible moves to make for the player
	ArrayList<Pair> moveAndBoard = new ArrayList<Pair> ();
    //The best move to make
    int best;
    //How  many moves to see forward
    int depth;
    //If game over, return true
    boolean gameOver;
    private int [][] myBoard;
    private int nextColMove;
	public boolean player;
	private static int RedPlayer = 1;
	private static int YellowPlayer = -1;
	private int myToken;
	private static final int COLUMNS = 7;
	private static final int ROWS= 6;
    	
    /**
     * 
     * @param b		the current board situation
     * @param depth	The number of moves seen forward
     */
    Stage (int [][] b, int depth) 
    {
    	int [][] myBoard = b;		
    	this.depth = depth;
    	
    	if (player)
    		myToken = YellowPlayer;
    	else
    		myToken = RedPlayer;
    	
    	//If no winner, the possibilities of how the board 
    	//could be set is added to the array list. 
    	//All the columns is tried.
    	if(Winner(myBoard))
    	{
    		this.gameOver = true;
    	}
    	else
    		// Iterate through the columns and choose a play
    		for(int row = 0; row < ROWS; row ++)
    		{
    			for(int col = 0; col <= (COLUMNS - 1) ; col++) 
    			{
    				if(legalMove(col))
    				{   
    					int myMove = col;
    					//The field is given a value
	    				myBoard[col][row]= myToken; 	

	    				//The move and the board situation are put 
	    				//together in a pair
	    				Pair nextPair = new Pair(myMove, myBoard);
	    				moveAndBoard.add(nextPair);
	    				System.out.println("Length of arrayList Pair(inde)" + moveAndBoard.size());
	    				

    				}
    			}
    		}
    	
    }

    public int getColMove()
    {
    	return nextColMove;
    }
    
		double max (double a, double b) 
	    {
			System.out.println("Length of arrayList Pair" + moveAndBoard.size());
	    	//If the request of future moves is 
			//less than zero - return 0.0
	    	if (this.depth < 0) {return 0.0;} 
	    	//If the game is over, return 1.0
	    	if (this.gameOver) {return -1.0;}
		
	    	else 
	    	{
	    		double newa = a;
	    		//Returns the move of the first board situation 
	    		//of the array list
	    		best = moveAndBoard.get(0).getMove();
	    		
	    		//gets the column of which the token is put into
	    		
	    		//Iterates through the whole array list of boards 
	    		//to find the best 
	    		//way for the player to play
	    		for (Iterator<Pair> i = moveAndBoard.iterator(); i.hasNext(); ) 
	    		{
	    			Pair p = i.next();
	    			int[][] board = p.getNextBoard();
	    			
	    			double n = new Stage (board, this.depth-1).min (a, b);
	    			System.out.println("n: " + n);
	    			if (newa < n) 
	    			{
	    				newa = n; best = moveAndBoard.get(0).getMove();;
	    				System.out.println("I'm here in board if (newa < n)");
	    			}
	    			if (b <= newa) 
	    			{
	    				return newa;
	    			}
	    		}
	    		return newa;
	    	}
	    }
	
	    double min (double a, double b) 
	    {
	    		if (this.depth < 0) 
	    		{
	    			return 0.0;
	    		} 
		
	    		if (this.gameOver) 
	    		{
	    			return 1.0;
				}
			
			else 
			{
			    double newb = b;
			    //Best move is the move of the first board
			    best = moveAndBoard.get(0).getMove();
			    //Iterates through the whole array list of boards 
			    //to find the best way for the player to play
			    for (Iterator<Pair> i = moveAndBoard.iterator (); i.hasNext (); ) 
			    {	
			    	Pair p = i.next();
			    	int[][] board = p.getNextBoard();
			    	double n = new Stage (board,  this.depth-1).max (a, b);
			    	if (n < newb) 
			    	{
			    		newb = n; best = moveAndBoard.get(0).getMove();
			    		System.out.println("I'm here in board if (n<newb)");
			    	}
					if (newb <= a) 
					{
						return newb;
					}
		    }
			    return newb;
		}
    }
	   //Checks whether the move is legal or not. 
	   //Parameter is the chosen column to play.
	   public boolean legalMove(int col)
	   {
		   if (col <= 6)
			{
				if(!(myBoard[col][0]== -1)||(myBoard[col][0]==1))
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else return false;
	   }
	    
	   //Returns true if four fields in a row in the double array 
	   //has the same value.
	    public boolean Winner(int[][]board)
	    {
	    	myBoard = board; 
	    	boolean win = false;
	    		
	    		for(int row = 0; row < ROWS; row++)
	    		{ 
	    			for (int col = 0; col < COLUMNS; col++)
	    			{ 
	    				
	    				//Goes through all rows to check 
	    				//if there is a winning situation
	    				if ((row+3) < ROWS)
	    				{
	    					if (myBoard[col][row] == myBoard[col][row+1] && 
	    							myBoard[col][row] == myBoard[col][row+2] &&
	    							myBoard[col][row]== myBoard[col][row+3] &&
	    							myBoard[col][row]!= 0)
	    					{
	    						win = true;
	    					}
	    				}
	    				
	    				//Goes through all columns to check 
	    				//if there is a winning situation
	    				if((col+3) < COLUMNS)
	    				{
	    					if (myBoard[col][row] ==  myBoard[col+1][row] &&
	    							myBoard[col][row] == myBoard[col+2][row] &&
	    							myBoard[col][row]== myBoard[col+3][row] &&
	    							myBoard[col][row]!= 0)
	    					{
	    						win = true;
	    					}
	    				}
	    				
	    				//Goes through all diagonals to check 
	    				//if there is a winning situation
	    				if((row + 3) < ROWS && (col+3) < COLUMNS)
	    				{
	    					if(myBoard[col][row] == myBoard[col+1][row+1] &&
	    							myBoard[col][row] == myBoard[col+2][row+2] && 
	    							myBoard[col][row] == myBoard[col+3][row+3] &&
	    							myBoard[col][row] != 0)
	    					{
	    						win = true;
	    					}
	    				}
	    				
	    				//Goes through all diagonals (opposite) to check 
	    				//if there is a winning situation
	    				 if ((row - 3)> 0 && (col+3) < COLUMNS )
	    				{
	    					if(myBoard[col][row] == myBoard[col+1][row-1] &&
	    							myBoard[col][row] == myBoard[col+2][row-2] &&
	    							myBoard[col][row] == myBoard[col+3][row-3] &&
	    							myBoard[col][row] != 0)
	    					{
	    						win = true;
	    					}
	    				}
	    			}
	    		}
	    		return win;	
	    	}
	 
	    //A class to put a possible move and the following 
	    //game board together in a pair
	    class Pair
	    {
	    	private int move;
	    	private int[][] boardView;
	    	
	    	public Pair (int move, int[][] boardView)
	    	{
	    		this.move = move;
	    		this.boardView = boardView;
	    	}
	    	 
	    	public int getMove()
	    	{
	    		return move;
	    	}
	    	
	    	public int[][] getNextBoard()
	    	{
	    		return boardView;
	    	}
	    }
}


//ArrayList<int[][]> boards = new ArrayList<int[][]>();

//ArrayList<Integer> moves = new ArrayList<Integer>();

//boards.add (myBoard); 
//aB.add(myBoard); System.out.println("er inde at add'e i aB");
//moves.add(col); System.out.println("er inde at add'e i moves " + moves.get(0));
////return; // Only one new token in each board