package NaderSalas;

public class GameBoard implements Cloneable


{
	public Move m=new Move(0,0);
	int[][] state;// = new int[2][69]; /** each player has an array of board state */
	int[][] boardSpace;// = new int[6][7]; /** 0=player1, 1=player 2, 2=empty */
	public int player;
	public GameBoard()
	{
		this.state = new int[2][69]; /** each player has an array of board state */
		this.boardSpace = new int[6][7]; /** 0=player1, 1=player 2, 2=empty */
		reSet();
	}	
	public GameBoard(int[][] state,int[][] boardSpace)
	{
		this.state = new int[2][69]; /** each player has an array of board state */
		this.boardSpace = new int[6][7]; /** 0=player1, 1=player 2, 2=empty */
		for (int r=0;r<6;r++)
			for (int c=0;c<7;c++)
				this.boardSpace[r][c]= boardSpace[r][c];
		for (int player=0;player<2;player++)
			for (int c4=0;c4<69;c4++)
				this.state[player][c4]= state[player][c4];
	}
	private void placeToken(Move m)
	{
		boardSpace[m.row][m.col]=player;
		for(Integer i:GroupMap.getGroupMap(m.row,m.col))
		{
			this.state[player][i]*=2;
			this.state[1-player][i]=0;
		}
	}
	
	public boolean isWinner()
	{
		boolean result=false;
		for(Integer i:GroupMap.getGroupMap(m.row,m.col))
		{
			if (this.state[this.player][i]==16){
				result=true;
				break;
			}
		}
		return result;
	}
	public boolean isTie()
	{
		for (int row=0;row<6;row++)
			for(int col=0;col<7;col++)
				if (this.boardSpace[row][col]==2)
					return false;
		return true;
	}
	public int getHeuristicMove() /** Evaluation of a move based on current situation */ 
	{
		int j=0,k=0;
		for(Integer i:GroupMap.getGroupMap(this.m.row, this.m.col))
		{
			j=j+state[this.player][i];
			k=k+state[1-this.player][i];
		}		
		return j-k;		
	}
	public boolean dropToken(int col, int player)
	{
		boolean result=false;
		for (int i=0;i<6;i++)
		{
			if(this.boardSpace[i][col]==2)// empty space
			{
				this.m.row=i;
				this.m.col=col;
				this.player=player;
				placeToken(this.m);
				result=true;
				break;
			}
		}	
		return result;
	}
	public void reSet(){
		for (int r=0;r<6;r++)
			for (int c=0;c<7;c++)
				this.boardSpace[r][c]= 2;
		for (int player=0;player<2;player++)
			for (int c4=0;c4<69;c4++)
				this.state[player][c4]= 1;
	}
	/** For debugging purpose */
	public void printHeuristicMove() /** Evaluation of a move based on current situation */ 
	{
		int j=0,k=0;
		for(Integer i:GroupMap.getGroupMap(this.m.row, this.m.col))
		{			
			j=j+state[this.player][i];
			k=k+state[1-this.player][i];
		}	
		System.out.println("For player "+this.player+" "+j);
		System.out.println("For player "+(1-this.player)+" "+k);
		System.out.println("For cel "+(this.m.row)+" "+(this.m.col));
		System.out.println(GroupMap.getGroupMap(this.m.row, this.m.col));
	}
	/** For debugging purpose */
	public void printB(int[][] board, int i,String s, int player)
	{
		System.out.println("The Move "+s+" dropToken is: "+i+"  Player is:"+player);
		for (int r=5;r>=0;r--)
		{
			System.out.print("|");
			for (int c=0;c<7;c++)
				System.out.print(board[r][c]+"|");
			System.out.println();
		}
	}
} 