import java.util.ArrayList;
import java.util.Date;


class RefBoard {
	int col,row;
	boolean[] boolPlayer = {true,false}; /** Matches 0 to True and 1 to false */

	private void delayMilli(long ms)
	{
	Date d = new Date();
	Date e;
	long cTime = d.getTime();
	long tTime;

	do
	{e = new Date();
	tTime = e.getTime();

	}while(tTime - cTime <= ms);

	return;
	}
	private int[][] boardSpace = new int[6][7]; /** 0=player1, 1=player 2, 2=empty */
	private ArrayList<Integer>[][] map = new ArrayList[6][7];
	private int[][] state = new int[2][69]; /** each player has an array of board state */
	public RefBoard(){
		//initialize map of the board
		for (int i=0;i<2;i++){
			for(int j=0;j<69;j++){
				state[i][j]=0;
			}
		}
		for (int row=0;row<6;row++){
			for(int col=0;col<7;col++){
				boardSpace[row][col]=2;
			}
		}
		
		for (int row=0;row<6;row++)
		{
			for(int col=0;col<7;col++)
				map[row][col]=new ArrayList(new ArrayList<Integer>());
		}
	// process row bottom up
		int groupNo=0;
		for (int row=0;row<6;row++)
		{
			for(int groupRow=0;groupRow<4;groupRow++)
			{
				for(int groupCol=0;groupCol<4;groupCol++)
					map[row][groupRow+groupCol].add(new Integer(groupNo));
			groupNo++;
			}
		}
	//Process column left to right
		for (int col=0;col<7;col++)
		{
			for(int groupRow=0;groupRow<3;groupRow++)
			{
				for(int groupCol=0;groupCol<4;groupCol++)
					map[groupRow+groupCol][col].add(new Integer(groupNo));
			groupNo++;
			}
		}
	//Process forward diagonal  
		for (int col=0;col<4;col++)
		{
			for (int row=0;row<3;row++)
			{
				for(int groupDiag=0;groupDiag<4;groupDiag++)
					map[row+groupDiag][col+groupDiag].add(new Integer(groupNo));
			groupNo++;
			}	
		}
	//Process backward diagonal 
		for (int col=0;col<4;col++)
		{
			for (int row=3;row<6;row++)
			{
				for(int groupDiag=0;groupDiag<4;groupDiag++)
				map[row-groupDiag][col+groupDiag].add(new Integer(groupNo));
			groupNo++;
			}	
		}	
		
	}
	public void insert(int column,boolean player) throws IllegalMove
	{
		int j;
		boolean result=true;
		if  (player) j=0; else j=1;
		for(int r=0;r<6;r++)
			if (boardSpace[r][column]==2)
				{
				boardSpace[r][column]=j;
				this.col=column;
				this.row=r;
				result=false;
				break;
				}
		if	(result)
			throw new IllegalMove(column);
		
	} /** Return IllegalMove exn.*/
	public boolean win(boolean winPlayer)
	{
		int j=1;
		if (winPlayer) j=0;
		for(Integer i:map[this.row][this.col])
			if (++state[j][i]==4)
				return true;
		return false;
	} /** Return true if the game is tie.*/
	public void print()
	{
		delayMilli(500);
		for (int r=5;r>=0;r--)
		{
			for (int c=0;c<8;c++)
				{
				System.out.print("|");
				if (c!= 7)
					{
					if (boardSpace[r][c]==0)
						System.out.print("x");
					if (boardSpace[r][c]==1)
						System.out.print("0");
					if (boardSpace[r][c]==2)
						System.out.print(" ");
					}
				}
			System.out.println("");
		}
		
		
	} /** Return true if the game is tie.*/
	public boolean tie() /** Return true if the game is tie.*/
	{
		for (int row=0;row<6;row++)
			for(int col=0;col<7;col++)
				if (boardSpace[row][col]==2)
					return false;
		return true;
	}

}