package NaderSalas;

import java.util.ArrayList;
import java.util.Iterator;

public class SearchMiniMax implements Runnable{
	GameBoard oldBoard;
	private SharedResources sr;
	int bestMove;
	int player;

	
	public SearchMiniMax(GameBoard oldBoard, int player, SharedResources sr){
		this.sr=sr;	
		this.oldBoard=oldBoard;
		this.player=player;
	}

	public double miniMaxAB(GameBoard oldBoard, int player,int depth, double Alpha, double Beta)
	{
		int t=-1;
		try{
			t=sr.getTime();
		} catch (InterruptedException e){}
		if (oldBoard.isWinner() || t < 2 || depth==0){
			double x=oldBoard.getHeuristicMove();
			if (oldBoard.isWinner())
			{
				if(oldBoard.player==0)
					x=10000.0;
				else
					x=-10000.0;
			}
			return x;
		}	
		
		if (oldBoard.isTie()) return 0.0;
		if (player==0) //player one
		{	
			ArrayList<GameBoard> ArGameBoard = new ArrayList<GameBoard> ();
			double newAlpha=Alpha;
			for (int column=0;column<7;column++)
				{
				GameBoard copyBoard=new GameBoard(oldBoard.state,oldBoard.boardSpace);
				copyBoard.m.row=oldBoard.m.row;
				copyBoard.m.col=oldBoard.m.col;			
				if (copyBoard.dropToken(column,player))
					ArGameBoard.add(copyBoard);
				}		
				for (Iterator<GameBoard> i = ArGameBoard.iterator (); i.hasNext (); )
					{
					GameBoard newBoard = i.next ();
					GameBoard anotherBoard=new GameBoard(newBoard.state,newBoard.boardSpace);					
					anotherBoard.m.row=newBoard.m.row;
					anotherBoard.m.col=newBoard.m.col;
					bestMove=anotherBoard.m.col;
					double score = miniMaxAB (anotherBoard,1-player,depth-1,Alpha, Beta);
					if (score > newAlpha) {newAlpha = score;bestMove=anotherBoard.m.col;}
					if (newAlpha >= Beta) {return newAlpha;}
					}
				
			return newAlpha;
		}
		else{  //player two
			ArrayList<GameBoard> ArGameBoard = new ArrayList<GameBoard> ();
			double newBeta=Beta;
			for (int column=0;column<7;column++)
				{				
				GameBoard copyBoard=new GameBoard(oldBoard.state,oldBoard.boardSpace);
				copyBoard.m.row=oldBoard.m.row;
				copyBoard.m.col=oldBoard.m.col;			
				if (copyBoard.dropToken(column,player))
					ArGameBoard.add(copyBoard);
				}
			for (Iterator<GameBoard> i = ArGameBoard.iterator (); i.hasNext ();)
				{
				GameBoard newBoard = i.next ();
				GameBoard anotherBoard=new GameBoard(newBoard.state,newBoard.boardSpace);					
				anotherBoard.m.row=newBoard.m.row;
				anotherBoard.m.col=newBoard.m.col;
				bestMove=anotherBoard.m.col;
				double score = miniMaxAB (anotherBoard,1-player,depth-1,Alpha, Beta);
				if (score < newBeta) {newBeta = score; bestMove=anotherBoard.m.col;}
				if (Alpha >= newBeta) {return newBeta;}
				}
	
			return newBeta;	
		}
	}
		
	public int getTimeLeft(){
		int result=-1;
		System.out.println("try to get time");
		try{
			result = sr.getTime();}
		catch(InterruptedException e){System.out.println(e.getMessage());};
		return result;
	}
	
	public void run(){
		try{
			miniMaxAB(this.oldBoard,this.player,7, -10000.0, 10000.0);
			sr.setNoDecTime();
			sr.setMove(this.bestMove);
		}
		catch (InterruptedException e){}
	}
	
	/** For debugging purpose */
	public void print(int[][] board, int i,String s, int player)
	{
		System.out.println("The Move "+s+" dropToken is: "+i+"  Player is:"+player);
		for (int r=5;r>=0;r--)
		{
			System.out.print("|");
			for (int c=0;c<7;c++)
				System.out.print(board[r][c]+"|");
			System.out.println();
		}
	}
	/** For debugging purpose */
	public void printState(int[][] board)
	{
		System.out.println("The board state..");
		for (int p=0;p<2;p++)
			for (int c=0;c<69;c++)
				System.out.println("Player "+p+" "+c+"="+board[p][c]);
	}
	public void printgroup(GameBoard gb){
		for(Integer i:GroupMap.getGroupMap(gb.m.row,gb.m.col))
		{
			System.out.println(i);
		}	
	}
	
}
