package NaderSalas;
/**
 * Project Connect 4
 * Assignment 13
 * @author Nader Salas
 * 10-12-2007
 */

import java.awt.geom.Ellipse2D;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JComponent;
import java.awt.Color;
import javax.swing.BorderFactory;
import java.awt.GridLayout;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.Timer;

import Player.Player;

import java.awt.Font;

/**
* CellComponent
* This is a special version of my Connect 4 game.
* Human to human player has been implemented with an eye toward implementation
* of human to computer implementation.
* There may be many unnecessary method and fields in which I am aware of that.
* 
* If you want the source code on disk, please let me know.
 */



class Board implements Player{
	public final static int TIMER_INITIAL = 18;
	java.util.Random generator;
	private ArrayList<Integer>[][] map = new ArrayList[6][7];
	private int[][] state = new int[2][69]; /** each player has an array of board state */
	private int[][] boardSpace = new int[6][7]; /** 0=player1, 1=player 2, 2=empty */
	private boolean IamFirstPlayer; /** This is to know who is the first player */
	private int turn=0,player=0,row=0,col=0;/** Keeping track of board coordinates, players and turn */
	private Timer boardTimer;  /** To update UI for human players */
	private int timeLeft=TIMER_INITIAL;
	
	public Board()
	{
		initBoard();
		resetBoard();
		generator = new java.util.Random();
	}
	public void init (Boolean color) /** Initialize player- first player->true opponent->false */
	{
		IamFirstPlayer = color;
	}
	public String name () /** Return author*/ 
	{return "Nader Salas";}
	public int move() /** Return computer's move */
	{
		int result=-1;
		if (IamFirstPlayer && turn==0){  // "red" is true meaning that first player
			result= 3;
		}			
		else
			result=getBestMove(player);
		turn++;
//		dropToken(result); //register the move I have just made
//		player=1-player;		
		return result;
	}
	public void inform (int i) /** Informs board the opponent/current-player's move 
	(because return type of "void" this will always be a Computer-opponent's move).
	For human player see "boolean informHuman(int i).*/
	{
		dropToken(i); //register the move that Computer opponent has just made
	}
	public boolean humanInform (int i) /** Because Carsten's "void inform(int i)" is void!!! */
	//human player make this move
	{
		if (dropToken(i)) // if it is a valid move
		{
			return true;
		}
		else
			return false;								
	}
	public void initBoard() /** Initialize the board variables for current game session.*/
	{
		//initialize map of the board
		for (int row=0;row<6;row++)
		{
			for(int col=0;col<7;col++)
				map[row][col]=new ArrayList(new ArrayList<Integer>());
		}
	// process row bottom up
		int groupNo=0;
		for (int row=0;row<6;row++)
		{
			for(int groupRow=0;groupRow<4;groupRow++)
			{
				for(int groupCol=0;groupCol<4;groupCol++)
					map[row][groupRow+groupCol].add(new Integer(groupNo));
			groupNo++;
			}
		}
	//Process column left to right
		for (int col=0;col<7;col++)
		{
			for(int groupRow=0;groupRow<3;groupRow++)
			{
				for(int groupCol=0;groupCol<4;groupCol++)
					map[groupRow+groupCol][col].add(new Integer(groupNo));
			groupNo++;
			}
		}
	//Process forward diagonal  
		for (int col=0;col<4;col++)
		{
			for (int row=0;row<3;row++)
			{
				for(int groupDiag=0;groupDiag<4;groupDiag++)
					map[row+groupDiag][col+groupDiag].add(new Integer(groupNo));
			groupNo++;
			}	
		}
	//Process backward diagonal 
		for (int col=0;col<4;col++)
		{
			for (int row=3;row<6;row++)
			{
				for(int groupDiag=0;groupDiag<4;groupDiag++)
				map[row-groupDiag][col+groupDiag].add(new Integer(groupNo));
			groupNo++;
			}	
		}	
	}
	public void resetBoard() /** Make the board ready for new game.*/
	{
		//this will also be called for new game
		//initialize state of the board
		turn=player=row=col=0;
		for (int i=0;i<2;i++){
			for(int j=0;j<69;j++){
				state[i][j]=0;
			}
		}
		for (int row=0;row<6;row++){
			for(int col=0;col<7;col++){
				boardSpace[row][col]=2;
			}
		}
	}
	public boolean isWinner() /** Check the internal map for possible winner, if there is one return true.*/
	{
		for(Integer i:map[this.row][this.col])
			if (++state[this.player][i]==4)
				return true;
		return false;
	}
	public int getPlayer() /** Returns the current player.*/
	{return this.player;}
	public boolean isTie() /** Return true if the game is tie.*/
	{
		for (int row=0;row<6;row++)
			for(int col=0;col<7;col++)
				if (boardSpace[row][col]==2)
					return false;
		return true;
	}
	public boolean dropToken(int col)/** Update internal arrays and return false if move is not valid. */
	{
		boolean result=false;
		for (int i=0;i<6;i++)
		{
			if(boardSpace[i][col]==2)// empty space
			{
				boardSpace[i][col]=player;
				this.row=i;
				this.col=col;
				player=1-player;
				result=true;
				break;
			}
		}
		return result;
	}
	public int getHeuristicMove(int n) /** Evaluation of a move based on current situation */ 
	{return -1;}
	public boolean isLeaf(int n) /** If this node (n) is the leaf of the game tree then return true. */
	{ return false;}
	public int getBestMove(int player) /** Prepare for best move.*/
	{return getRandomMove();}
	public int getMiniMax(int n,int depth, int min, int max) /** Use minimax recursively maybe with 
	AB-pruning.*/
	{ 
		//this is just a thought
		if (isLeaf(n) || depth==0 || timeLeft==1) return getHeuristicMove(n);
		else
			
		return -1;		
	}
	public int getRandomMove() /** For test.*/
	{
		ArrayList<Integer> randNumbers = new ArrayList<Integer>();
		
		for (int col=0;col<7;col++)
			for (int row=0;row<6;row++)
				if (boardSpace[row][col] == 2)
				{
					randNumbers.add(new Integer(col));
					break;
				}

		int i=randNumbers.size();
		if (!(i<= 0))
			return randNumbers.get(generator.nextInt(i));
		else
			return -1;
	}
	public int getBordRow() /** Return board row for last play.*/
	{return row;}
	public int getTurn() /** Return turn.*/
	{
		return turn;
	}
	public int getBordCol() /** Return board column for last play.*/
	{return col;}
}



public class testConnect4 {	
	final static int WIDTH =600;
	final static int HEIGHT =680;	
		public static void main(String[] args){
			JFrame frame= new JFrame("Connect 4");
			GUI com = new GUI(frame.getContentPane());
			frame.add(com);
			frame.setSize(WIDTH, HEIGHT);
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.setVisible(true);	
		}
	}
