package PeterRaahauge;

public class Board {
	
	// A logical board with 12x13 locations are set up. In this way, it can 
	// be checked if there is a winner, without having to take care of boundaries
	
	// Zero is clear, 1 is red, 2 is yellow
	public Board()
	{
		boardArrayLogic = new int[ROWSLOGIC][COLSLOGIC];
		for(int i = 0;i<ROWSLOGIC; i++)
			for(int j = 0; j<COLSLOGIC; j++)
				boardArrayLogic[i][j] = 0;
	}
	
	// This function returns the board without the extra columns and rows
	public int[][] boardArrayOut()
	{
		int[][] outArray = new int[ROWS][COLS];
	
		for(int i = 0;i<ROWS; i++)
			for(int j = 0; j<COLS; j++)
				outArray[i][j] = boardArrayLogic[3+i][3+j];
		return outArray;
	}

	// This function sets in a new token and returns the row location
	// (if not assigned due to filled column,
	// the error value 999 is returned.
	public int newToken(int tokenCol,boolean color)
	{
		int colIx = tokenCol-1;
		r = 999;
		for(int i = 0;i<ROWS; i++)
		{
			if(boardArrayLogic[3+i][3+colIx]>0);
			else 
			{
				boardArrayLogic[3+i][3+colIx] = color2Int(color);
				
				// Properties of last placed token is saved
				r = i;
				c = colIx;
				lastPlayer = color;
				return (r+1);
			}
			
		}
		return r; // If no value assigned before i = ROWS...
	}

	
	//   the Value of the board (i = 0..ROWS-1, j = 0.. COLS-1
	public int getBoardValue(int i, int j)
	{
		return boardArrayLogic[i+3][j+3];		
	}
	
	//  the Value of the board (i = 0..ROWS-1, j = 0.. COLS-1
	//public void setBoardValue(int i, int j,boolean color)
	//{
	//	boardArrayLogic[i+3][j+3] = color2Int(color);		
	//}
	
	
	// This function checks for winners. 
	// If product is 1*1*1*1 = 1 then red wins
	// If product is 2*2*2*2 = 16 then yellow wins
	public int winner()
	{
		int result = 0;
		int i = r + 3;
		int j = c + 3;
		int[][] b = boardArrayLogic;
		
		int checkResult; 		
		if(lastPlayer) checkResult =1; // Red player was last player 
		else checkResult = 16; // Yellow player
		
		if(		checkResult == b[i][j]*b[i+1][j]*b[i+2][j]*b[i+3][j] | 
				checkResult == b[i-1][j]*b[i][j]*b[i+1][j]*b[i+2][j] |
				checkResult == b[i-2][j]*b[i-1][j]*b[i][j]*b[i+1][j] |
				checkResult == b[i-3][j]*b[i-2][j]*b[i-1][j]*b[i][j] |
				
				checkResult == b[i][j]*b[i][j+1]*b[i][j+2]*b[i][j+3] |
				checkResult == b[i][j-1]*b[i][j]*b[i][j+1]*b[i][j+2] |
				checkResult == b[i][j-2]*b[i][j-1]*b[i][j]*b[i][j+1] |
				checkResult == b[i][j-3]*b[i][j-2]*b[i][j-1]*b[i][j] |
				
				checkResult == b[i][j]*b[i+1][j-1]*b[i+2][j-2]*b[i+3][j-3] |
				checkResult == b[i-1][j+1]*b[i][j]*b[i+1][j-1]*b[i+2][j-2] |
				checkResult == b[i-2][j+2]*b[i-1][j+1]*b[i][j]*b[i+1][j-1] |
				checkResult == b[i-3][j+3]*b[i-2][j+2]*b[i-1][j+1]*b[i][j] |

				checkResult == b[i][j]*b[i+1][j+1]*b[i+2][j+2]*b[i+3][j+3] |
				checkResult == b[i-1][j-1]*b[i][j]*b[i+1][j+1]*b[i+2][j+2] |
				checkResult == b[i-2][j-2]*b[i-1][j-1]*b[i][j]*b[i+1][j+1] |
				checkResult == b[i-3][j-3]*b[i-2][j-2]*b[i-1][j-1]*b[i][j]
				                                                  )
		result = color2Int(lastPlayer);
		
		return result;
	}
	
	// This function change the color from "true" to 1 or "false" to 2
	private int color2Int(boolean color)
	{
		if(color)
			return 1;
		else
			return 2;
	}
	
	// Shows the board in a text string
	public String toString()
	{
		String s = "";
		for(int i = ROWS-1;i>=0; i--){
			for(int j = 0; j<COLS; j++){
				s = s + boardArrayLogic[3+i][3+j];
			}
			s = s + "\n";
		}
		return s;
	}
	
	private int[][] boardArrayLogic; 
	
	// Last token location
	private int c; // Column index 
	private int r; // Row index
	private boolean lastPlayer; //Color
	
	private static final int ROWSLOGIC = 12;
	private static final int COLSLOGIC = 13;
	private static final int ROWS = 6;
	private static final int COLS = 7;
	
	

}
