//Projekt Connect4
//@date 17-12-2007
//@author Tomas Kegel Srensen
package TomasKegelSorensen;


//This class represent the board
public class Board {

    // if value = 0 then no brick has been placed yet, if -1 then red brick and
    // if 1 then YELLOW brick has been placed
    int[][] board = new int[6][7];
    Move larstMove = null;

    public Board() 
    {
    }
    //This insert a move into the board
    public void insert(Move move, boolean player) {
        if (player)
            board[move.y][move.x] = 1;
        else
            board[move.y][move.x] = -1;

    }
    //This removes a move from the board
    public void remove(Move move) {
        board[move.y][move.x] = 0;
    }
    //Here is it checked if anyone have won the game. When a checker is placed, the findPotentialWinner will search from the current position, if there is 4 on a row
    public String findPotentialWinner(Move move, boolean player) {
        boolean tempInsert = false;
        int playerValue = -1;
        if (player)
            playerValue = 1;
        int onARow = 0;
        if (this.board[move.y][move.x] == 0) {
            this.insert(move, player);
            tempInsert = true;
        }

        // Checks for 4 on a row vertical
        for (int i = 0; i < board[move.y].length; i++) {
            if (board[move.y][i] == playerValue)
                onARow++;
            else
                onARow = 0;
            if (onARow == 4) {
                if (tempInsert)
                    this.remove(move);
                if (player)// Human player
                    return "RED";
                return "YELLOW";
            }
        }
        onARow = 0;
        // Checks for 4 on a row horizontal
        for (int i = 0; i < board.length; i++) {
            if (board[i][move.x] == playerValue)
                onARow++;
            else
                onARow = 0;
            if (onARow == 4) {
                if (tempInsert)
                    this.remove(move);
                if (player)// Human player
                    return "RED";
                return "YELLOW";
            }
        }
        // Diagonal left down to right up
        onARow = 0;
        Move[] diagonalMoves = findDiagonalMoves(true, move);
        for (int i = 0; i < diagonalMoves.length; i++) {
            if (diagonalMoves[i] != null) {
                if (board[diagonalMoves[i].y][diagonalMoves[i].x] == playerValue)
                    onARow++;
                else
                    onARow = 0;
                if (onARow == 4) {
                    if (tempInsert)
                        this.remove(move);
                    if (player)// Human player
                        return "RED";
                    return "YELLOW";
                }
            } else
                onARow = 0;
        }

        // Diagonal left up to right down
        onARow = 0;
        Move[] diagonalMoves1 = findDiagonalMoves(false, move);
        for (int i = 0; i < diagonalMoves1.length; i++) {
            if (diagonalMoves1[i] != null) {
                if (board[diagonalMoves1[i].y][diagonalMoves1[i].x] == playerValue)
                    onARow++;
                else
                    onARow = 0;
                if (onARow == 4) {
                    if (tempInsert)
                        this.remove(move);
                    if (player)// Human player
                        return "RED";
                    return "YELLOW";
                }
            } else
                onARow = 0;
        }

        if (tempInsert)
            this.remove(move);
        return "NO WINNER YET";
    }
    //This returns the moves that give 4 on a row
    private Move[] findDiagonalMoves(boolean b, Move startMove) {
        Move[] moves = new Move[7];
        if (b)// Left down to up
        {
            for (int i = 0; i < moves.length; i++) {
                if ((startMove.y + startMove.x - i) >= 0
                        && (startMove.y + startMove.x - i) <= 5)
                    moves[i] = new Move(i, startMove.y + startMove.x - i);
            }
        } else// Left up to down
        {
            for (int i = 0; i < moves.length; i++) {
                if ((startMove.y - startMove.x + i) >= 0
                        && (startMove.y - startMove.x + i) <= 5)
                    moves[i] = new Move(i, startMove.y - startMove.x + i);
            }
        }

        return moves;
    }
    //Find the next possible place in a colum to place a checker
    public int findNextAvaliableSpot(int x) {
        for (int i = 5; i > -1; i--) {
            if (board[i][x] == 0)
                return i;
        }
        return -1;
    }
    //Checks if the game is over
    public boolean gameOver() {
        int counter = 0;
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length; j++) {
                if (board[i][j] != 0)
                    counter++;
            }
        }
        if (counter >= 42)
            return true;
        return false;
    }

    //This checks is the game is a tie
    public boolean tie() {
        int counter = 0;
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length; j++) {
                if (board[i][j] != 0)
                    counter++;
            }
        }
        if (counter >= 42)
            return true;
        return false;
    }
    // The below methods have been made to work with the ref.java
    public void insert(int move, boolean player) {
        int y = this.findNextAvaliableSpot(move);
        this.insert(new Move(move, y), player);
        larstMove = new Move(move, y);

    }

    public boolean win(boolean player) {
        if (!this.findPotentialWinner(larstMove, player)
                .equals("NO WINNER YET")) {
            return true;
        } else
            return false;
    }

}
