//Projekt Connect4
//@date 17-12-2007
//@author Tomas Kegel Srensen


import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

// This class makes the board layout and the actions that is connected to it.
class BoardLayout extends JFrame implements ActionListener {
    JPanel grid = new JPanel();
    JPanel buttonPanel = new JPanel();
    JPanel infoPanel = new JPanel();
    JLabel infoLabel = new JLabel("Player to take action is RED");
    JButton[] addBricks = new JButton[7];
    JButton newGameButton = new JButton("New Game");
    Canvas[][] bricks = new Canvas[6][7];
    boolean playerToTakeAction = true;
    Board board = new Board();
    Tomas AutoTomas = new Tomas();
    Tomas razor = new Tomas();

    // This constructor creates the layout for the JFrame with 3 panels:
    // addCheckerbuttons, checkergrid, infolabels
    public BoardLayout() {
        this.setSize(800, 800);

        AutoTomas.init(new Board());
        AutoTomas.setPlayerType(false);

        razor.init(new Board());
        razor.setPlayerType(true);
        buttonPanel.setLayout(new GridLayout(1, 7));
        grid.setLayout(new GridLayout(6, 7));
        this.getContentPane().setLayout(new BorderLayout());

        for (int i = 0; i < addBricks.length; i++) {
            addBricks[i] = new JButton("ADD" + i);
            addBricks[i].addActionListener(this);
            buttonPanel.add(addBricks[i]);
        }
        Color color = Color.BLACK;
        for (int i = 0; i < bricks.length; i++) {
            for (int j = 0; j < bricks[i].length; j++) {
                bricks[i][j] = new Canvas();
                bricks[i][j].setSize(20, 20);

                if (color.equals(Color.BLACK))
                    color = Color.WHITE;
                else
                    color = Color.BLACK;

                bricks[i][j].setBackground(color);
                grid.add(bricks[i][j]);
            }
        }
        newGameButton.addActionListener(this);
        infoPanel.add(infoLabel);
        infoPanel.add(newGameButton);

        // This adds the 3 panels to JFrame
        this.getContentPane().add(grid, BorderLayout.CENTER);
        this.getContentPane().add(buttonPanel, BorderLayout.NORTH);
        this.getContentPane().add(infoPanel, BorderLayout.SOUTH);

    }

    // All the actions that happens when then buttons are pressed.
    public void actionPerformed(ActionEvent arg0) {
        for (int i = 0; i < addBricks.length; i++) {
            // Find out which checkerbuttons has been pressed/activated.
            if (arg0.getActionCommand().equals(addBricks[i].getText())) {

                int x = i;
                int y = board.findNextAvaliableSpot(x);
                Move move = new Move(x, y);
                if (y != -1) {
                    playerToTakeAction = true;
                    addBrick(move);
                    String winner;
                    // If move let to a winning position, write out the
                    // winner and disable the layout
                    if (!(winner = board.findPotentialWinner(move,
                            playerToTakeAction)).equals("NO WINNER YET")) {
                        infoLabel.setText("WINNER IS " + winner);
                        disableLayout();
                    }
                }
                String winner;

                if (!infoLabel.getText().startsWith("WINNER IS")) {
                    playerToTakeAction = false;// AutoTomas
                    AutoTomas.inform(move);
                    Move AutoTomasMove = AutoTomas.move();
                    addBrick(AutoTomasMove);

                    if (!(winner = board.findPotentialWinner(AutoTomasMove,
                            playerToTakeAction)).equals("NO WINNER YET")) {
                        infoLabel.setText("WINNER IS " + winner);
                        disableLayout();
                    }
                    razor.inform(AutoTomasMove);

                } 
                
                if (board.gameOver()&&!infoLabel.getText().startsWith("WINNER IS")) {

                    infoLabel.setText("Game is a tie");
                    
                }
            }
        }
        if (arg0.getActionCommand().equals("New Game")) {
            enableLayout();
        }
    }
    //Sets all the checkerbuttons to false, so they are hidding and not possible to use
    private void disableLayout() {
        for (int i = 0; i < addBricks.length; i++) {
            addBricks[i].setVisible(false);
        }
    }
    // Resets the intire board
    private void enableLayout() {
        for (int i = 0; i < addBricks.length; i++) {
            addBricks[i].setVisible(true);
        }
        // reinitialize field variables
        playerToTakeAction = true;
        infoLabel.setText("Player to take action is RED");
        AutoTomas.init(new Board());
        razor.init(new Board());
        board = new Board();

        Color color = Color.BLACK;
        for (int i = 0; i < bricks.length; i++) {
            for (int j = 0; j < bricks[i].length; j++) {
                if (color.equals(Color.BLACK))
                    color = Color.WHITE;
                else
                    color = Color.BLACK;

                bricks[i][j].setBackground(color);
            }
        }
    }

    // Adds checkers
    private void addBrick(Move move) {
        board.insert(move, playerToTakeAction);
        Color brickColor = Color.YELLOW;
        if (playerToTakeAction)// Human player
            brickColor = Color.RED;

        bricks[move.y][move.x].setBackground(brickColor);
    }

}