//Projekt Connect4
//@date 17-12-2007
//@author Tomas Kegel Srensen

package TomasKegelSorensen;
import Player.Player;

public class TomasKegelSorensen implements Player {

    Board board;
    private int recurDepth = 0;
    private int MAX_RECURDEPTH = 7;
    private int depth = 7;
    boolean playerType;

    public void inform(Move m) {
        // insert other players action
        board.insert(m, true);
    }

    public void setPlayerType(boolean type) {
        this.playerType = type;
    }

    public void init(Board b) {

        this.board = b;
    }

    public Move move() {

        // Use the Minimax algoritm from Jason Fletchall
        int rowNextMove = -1;
        int colNextMove = -1;
        Minimax minmax = new Minimax();
        minmax.minFlag = !playerType;
        // store a tempBoard so that it will not get overwritten in Jasons
        // minimax class
        int[][] minmaxBoard = new int[6][7];

        for (int i = 0; i < board.board.length; i++) {
            for (int j = 0; j < board.board[i].length; j++) {
                minmaxBoard[i][j] = board.board[i][j];
            }
        }
        // set the board in the minimax class
                                         
        minmax.setGameBoard(minmaxBoard);
        //Starts the thread
        minmax.start();
        try {
            // Increase sleep time to allow minimax to go
            // into greater depths, measure in miliseconds.
            // Set to 1 sec here, for the compatition it is set to 15 sec
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            System.out.println("exception occurred.  this is a bad thing.");
        }
        // When sleep is over interrupt minimax class and
        // retrive the best move it got so far
        minmax.interrupt();
        rowNextMove = minmax.rowNextMove;
        colNextMove = minmax.colNextMove;
        
        // Throw away the minimax class.
        minmax = null;
        
        
        // create the move and insert it into the board       
        Move move = new Move(colNextMove, rowNextMove);
        board.insert(move, playerType);
        return move;

    }

    public String name() {

        return "AutoTomas, the unbeatable four on a row player";
    }

}
