
class Board 
{
	private int[][] gridsOnBoard;
	private final int rows = 6;
	private final int columns = 7;
	private boolean player_turn;
	private int aMove;
	private boolean winner_found;
	private String winner;
	private int start_index;
	
    public Board () 
    {
    	gridsOnBoard = new int[rows][columns];
    	player_turn = true;
    	winner = "";
    }

    public void insert(int aMove)throws IllegalMove 
    {
		if(aMove!=-10)
		{
			this.aMove = aMove;
	    	if (this.isValid (aMove)) 
			{
				boolean inserted = false;
				int i = rows-1;
				while(i>=0&&!inserted)
				{
					if(gridsOnBoard[i][aMove]==1||gridsOnBoard[i][aMove]==2)
						i--;
					else
					{
						if(player_turn)
							gridsOnBoard[i][aMove] = 1;
						else
							gridsOnBoard[i][aMove] = 2;
						inserted = true;
					}
				}
				start_index = i;
				
				if(gridsOnBoard[0][aMove]!=1)
					gridsOnBoard[0][aMove]=0;
				
				if(!win()) 
					player_turn = !player_turn;
				else
					winner_found = true;
			}
			
			else 
			{
			    throw (new IllegalMove(aMove));
			}
		}
		else
			player_turn = false;
    }

    public boolean winnerFound()
    {
    	return winner_found;
    }
    
    private boolean isValid (int m) 
    {
		return (m>=0 && m<columns && gridsOnBoard[0][m]!=1);  //And not occupied. ֹܲЩҪ
    }

    //Decide who wins. 
    public boolean win() 
    {
    	if(checkVertically())
    		return true;
    	else if(checkHorizontally())
    		return true;
    	else if(checkLeftDiagonally())
    		return true;
    	else if(checkRightDiagonally())
    		return true;
    	else
    		return false;
    }   
    
    //Check Vertically.
    private boolean checkVertically()
    {
    	int no_in_line = 0;
    	int temp = 0;
    	if(player_turn)
    		temp = 1;
    	else
    		temp = 2;
    	
    	int i = start_index;
    	boolean stop = false;
    	while(i<rows&&!stop)
    	{
    		if(gridsOnBoard[i][aMove]==temp)
    		{
    			no_in_line++;
    			i++;
    		}
    		else
    			stop = true;	
    	}
    	
    	if(no_in_line<4)
    		return false;
    	else
    	{
    		if(temp == 1) 
    		{
    			System.out.println("Winner is Player Xiang Ge.");
    			winner = "HumanPlayer";
    		}
    		else
    		{
    			System.out.println("Winner is Automatic player.");
    			winner = "AutoPlayer";
    		}
    		return true;
    	}
    }
    
    //Check Horizontally.
    private boolean checkHorizontally()
    {
    	int no_in_line = 0;
    	int temp = 0;
    	if(player_turn)
    		temp = 1;
    	else
    		temp = 2;
    	
    	int i = aMove;
    	boolean stop = false;
    	while(i<columns&&!stop)
    	{
    		if(gridsOnBoard[start_index][i]==temp)
    		{
    			no_in_line++;
    			i++;
    		}
    		else
    			stop = true;	
    	}
    	
    	i = aMove-1;
    	stop = false;
    	while(i>=0&&!stop)
    	{
    		if(gridsOnBoard[start_index][i]==temp)
    		{
    			no_in_line++;
    			i--;
    		}
    		else
    			stop = true;	
    	}
    	
    	if(no_in_line<4)
    		return false;
    	else
    	{
    		if(temp == 1) 
    		{
    			System.out.println("Winner is Player Xiang Ge.");
    			winner = "HumanPlayer";
    		}
    		else
    		{
    			System.out.println("Winner is Automatic player.");
    			winner = "AutoPlayer";
    		}
    		return true;
    	}
    }
    
    //Check LeftDiagonally.
    private boolean checkLeftDiagonally()
    {
    	int no_in_line = 0;
    	int temp = 0;
    	if(player_turn)
    		temp = 1;
    	else
    		temp = 2;
    	
    	int i = start_index;
    	int j = aMove;
    	boolean stop = false;
    	while(i<rows&&j<columns&&!stop)
    	{
    		if(gridsOnBoard[i][j]==temp)
    		{
    			no_in_line++;
    			i++; j++;
    		}
    		else
    			stop = true;	
    	}
    	
    	i = start_index-1;
    	j = aMove-1;
    	stop = false;
    	while(i>=0&&j>=0&&!stop)
    	{
    		if(gridsOnBoard[i][j]==temp)
    		{
    			no_in_line++;
    			i--; j--;
    		}
    		else
    			stop = true;	
    	}
    	
    	if(no_in_line<4)
    		return false;
    	else
    	{
    		if(temp == 1) 
    		{
    			System.out.println("Winner is Player Xiang Ge.");
    			winner = "HumanPlayer";
    		}
    		else
    		{
    			System.out.println("Winner is Automatic player.");
    			winner = "AutoPlayer";
    		}
    		return true;
    	}
    }
    
    //Check RightDiagonally.
    private boolean checkRightDiagonally()
    {
    	int no_in_line = 0;
    	int temp = 0;
    	if(player_turn)
    		temp = 1;
    	else
    		temp = 2;
    	
    	int i = start_index;
    	int j = aMove;
    	boolean stop = false;
    	while(i>=0&&j<columns&&!stop)
    	{
    		if(gridsOnBoard[i][j]==temp)
    		{
    			no_in_line++;
    			i--; j++;
    		}
    		else
    			stop = true;	
    	}
    	
    	i = start_index+1;
    	j = aMove-1;
    	stop = false;
    	while(i<rows&&j>=0&&!stop)
    	{
    		if(gridsOnBoard[i][j]==temp)
    		{
    			no_in_line++;
    			i++; j--;
    		}
    		else
    			stop = true;	
    	}
    	
    	if(no_in_line<4)
    		return false;
    	else
    	{
    		if(temp == 1) 
    		{
    			System.out.println("Winner is Player Xiang Ge.");
    			winner = "HumanPlayer";
    		}
    		else
    		{
    			System.out.println("Winner is Automatic player.");
    			winner = "AutoPlayer";
    		}
    		return true;
    	}
    }
    
    public String getWinner()
    {
    	return winner;
    }
    
    public int[][] getBorad()
    {
    	return gridsOnBoard;
    }
    
    public boolean playerTurn()
    {
    	return player_turn;
    }
}
