import java.awt.*;
import javax.swing.*;
import java.util.*;

public class Canvas extends JComponent implements Runnable
{	
	private Board board;
	private int current_move;
	
	public Canvas(Board b) 
	{
		board = b;
		Thread thread=new Thread(this);
		thread.start();   
    }
		
	public void run()
	{
		while(true)
		{
			try
		    {
				Thread.sleep(50);
			}
		    catch(Exception e)
			{
				System.out.println(e);
			}
			repaint();
		}	   
	}
	
	public synchronized void paint(Graphics g)
    {	    
		//Draw grid borad
		g.setColor(Color.black);
		g.fillRect(420, 0, 60, 361);
		
		for(int i = 0; i<6;i++)
		{
			for(int j = 0; j<7; j++)
			{	
				g.setColor(new Color(192,192,192));
				g.fillOval((j)*60, (i)*60, 60, 60);  
			}
		}
		
		int [][]h_player_moves = board.getBorad();
		for(int i = 0; i<h_player_moves.length;i++)
		{
			for(int j = 0; j<h_player_moves[0].length; j++)
			{	
				if(h_player_moves[i][j]==1)
				{
					g.setColor(Color.yellow);
					g.fillOval((j)*60, (i)*60, 60, 60);  
				}
				if(h_player_moves[i][j]==2)
				{
					g.setColor(Color.red);
					g.fillOval((j)*60, (i)*60, 60, 60);  
				}
			}
		}
		
		if(board.getWinner().equals("HumanPlayer"))
		{
			g.setColor(Color.blue);
			g.setFont(new java.awt.Font("Lucida Sans Unicode", Font.BOLD, 28)); 
			g.drawString("Winner is Xiang Ge!", 60,150);
		}
		else if(board.getWinner().equals("AutoPlayer"))
		{
			g.setColor(Color.blue);
			g.setFont(new java.awt.Font("Lucida Sans Unicode", Font.BOLD, 28)); 
			g.drawString("Winner is AutoPlayer!", 60,150);
		}
		else
		{
			g.setColor(Color.yellow);
			g.fillOval(current_move*60, 0, 60, 60);
		}
    }
    
	public void setCurrentMove(int m)
	{
		current_move = m;
	}
			
    public Dimension getPreferredSize()
    {
    	return new Dimension(480,360);
    }
    
    public Dimension getMinimumSize()
    {
    	return new Dimension(480,360);
    }
}
	