import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class GameGUI extends JFrame
{		
	private HumanPlayer human_player;
	private Canvas canvas;
	private Container pane;
	private int a_move;
	private Board board;
	
	public GameGUI(HumanPlayer human_player,Board b) 
	{
		board = b;
		initGUI();
		this.human_player = human_player;	
	}
	
	private void initGUI() 
	{
		this.setTitle("Connect4 Game");
		pane=this.getContentPane();
		
		canvas=new Canvas(board);
		pane.add(canvas,BorderLayout.WEST);	
		pane.setBackground(new Color(28,60,121));
		
		this.setSize(480,395);
		this.setVisible(true);
		
		this.addKeyListener(
			new KeyAdapter()
			{
				public void keyPressed(KeyEvent e)
				{
					if(e.getKeyCode()==KeyEvent.VK_LEFT)
					{
						if(a_move>0)
						{
							a_move--;
							canvas.setCurrentMove(a_move);
						}
					}
					if(e.getKeyCode()==KeyEvent.VK_RIGHT)
					{	
						if(a_move<6)
						{
							a_move++;
							canvas.setCurrentMove(a_move);
						}
					}
					
					if(e.getKeyCode()==KeyEvent.VK_ENTER)
					{	
						human_player.setAMove(a_move);
					}
				}
			});	
	}
	
	public static void main(String args[])
	{
		HumanPlayer human_player = new HumanPlayer();
		AutomaticPlayer automatic_player = new AutomaticPlayer();
		Board b = new Board();
		
		new GameGUI(human_player,b);
		new GameController(human_player,automatic_player,b);
	}
}
	 