
class GameController
{
    Board b; 
    HumanPlayer p1;   /* p1 plays true */
    AutomaticPlayer p2;   /* p2 plays false */

    public GameController (Player p1, Player p2, Board b) 
    {
    	this.b = b;
		this.p1 = (HumanPlayer)p1; 
		this.p2 = (AutomaticPlayer)p2;
		p1.init();
		p2.init();
		run();
    }

    public void illegal (String s, int move) 
    {
    	System.out.println ("Illegal Move: Player " +  s + " moved to (" + move +")");
    }

    public int move (boolean player) 
    {
		if (player) 
		{
			int player_move = p1.move();
			try 
		    {
		    	b.insert (player_move); 
		    	p1.setAMove(-1);
		    }
		    catch (IllegalMove exn) 
		    {
		    	illegal (p1.name(), player_move); 
		    	return -1;
		    }
		    
		    p2.inform (player_move); 
		}
		else 
		{
			int automatic_move = p2.move();
			try 
		    {
		    	b.insert (automatic_move);
		    }
		    catch (IllegalMove exn) 
		    {
		    	illegal (p2.name(), automatic_move); 
		    	return -1;
		    }
		    
		    p1.inform (automatic_move);
		}
		
		if(!b.winnerFound())
			return (move (! player));   
		else
			return -1;
    }
    
    public void run () 
    {
		move(true); //Human player first.
    }
}
